---
# options: https://clang.llvm.org/docs/ClangFormatStyleOptions.html
Language: Cpp
Standard: c++20

IndentWidth: 4
TabWidth: 8
UseTab: Never
ContinuationIndentWidth: 8
AccessModifierOffset: -4
ConstructorInitializerIndentWidth: 4
ColumnLimit: 160

BreakBeforeBraces: Custom
BraceWrapping:
  AfterCaseLabel: true
  AfterClass: true
  AfterControlStatement: Always
  AfterEnum: true
  AfterFunction: true
  AfterNamespace: true
  AfterObjCDeclaration: true
  AfterStruct: true
  AfterUnion: true
  AfterExternBlock: true
  BeforeCatch: true
  BeforeElse: true
  IndentBraces: false
NamespaceIndentation: All
FixNamespaceComments: true
IndentCaseLabels: true
IndentCaseBlocks: true
IndentPPDirectives: BeforeHash

SeparateDefinitionBlocks: Always
SpaceAfterCStyleCast: false
SpaceBeforeAssignmentOperators: true
SpaceBeforeParens: ControlStatements
SpaceInEmptyParentheses: false
SpacesBeforeTrailingComments: 2
SpacesInAngles: Never
SpaceAfterTemplateKeyword: false
SpacesInContainerLiterals: false
SpacesInCStyleCastParentheses: false
SpaceInEmptyBlock: true
SpacesInParentheses: false
SpacesInSquareBrackets: false
Cpp11BracedListStyle: true
SpaceBeforeCpp11BracedList: false
BitFieldColonSpacing: After

DerivePointerAlignment: false
PointerAlignment: Left

QualifierAlignment: Custom
QualifierOrder: ['static', 'inline', 'type', 'const']

SortIncludes: CaseInsensitive
IncludeCategories:
  - Regex: '^<.*\.h>'
    Priority: 4
  - Regex: '^<.*>'
    Priority: 1
  - Regex: '^".*\.h"'
    Priority: 6
SortUsingDeclarations: true

MaxEmptyLinesToKeep: 1
KeepEmptyLinesAtTheStartOfBlocks: false

AlignAfterOpenBracket: DontAlign
AlignArrayOfStructures: Right
AlignConsecutiveAssignments: None
AlignConsecutiveDeclarations: None
AlignConsecutiveMacros: None
AlignEscapedNewlines: DontAlign
AlignOperands: DontAlign
AlignTrailingComments: false

AllowAllArgumentsOnNextLine: false
AllowAllParametersOfDeclarationOnNextLine: false
AlwaysBreakAfterReturnType: None
AlwaysBreakTemplateDeclarations: Yes
AllowShortBlocksOnASingleLine: Empty
AllowShortCaseLabelsOnASingleLine: false
AllowShortEnumsOnASingleLine: true
AllowShortFunctionsOnASingleLine: Empty
AllowShortLambdasOnASingleLine: Inline
AllowShortIfStatementsOnASingleLine: false
AllowShortLoopsOnASingleLine: false

BinPackArguments: true
BinPackParameters: true
...
